--------------------------------------------------------------------------------
-- Это тестовая версия аддона переключения между каналами чата...
-- Приватные сообщение не работают... пока... :) для этого Reset(*) жмите
--------------------------------------------------------------------------------
-- GLOBALS
--------------------------------------------------------------------------------
Global("WXMainPanel", nil)

Global("WBGeneralButton", nil)
Global("WBZoneButton", nil)
Global("WBTellButton", nil)
Global("WBReButton", nil)

Global("WBRaidWarButton", nil)
Global("WBRaidButton", nil)
Global("WBPartyButton", nil)
Global("WBGuildButton", nil)
Global("WBOfficerButton", nil)

Global("WBMystButton", nil)
Global("WBYellButton", nil)
Global("WBWorldButton", nil)

Global("SPlayerName", common.GetEmptyWString())

--Global("wtXMainPanel",nil)
--Global("wtXEditLine",nil)
Global("isOpenChat",false)

--------------------------------------------------------------------------------
-- HELPER FUNCTIONS
--------------------------------------------------------------------------------

-- AO game Version detection by SLA, ver. 2010-09-09.
function GetGameVersion()
	if social.GetFriendInfo then return 1104
	elseif object.IsFar then return 1103
	elseif guild.GetAllods then return 1102
	elseif avatar.GetEmotes then return 1101
	end
	return 1100
end

function GetGameLocalization()
	local L = cartographer.GetMapBlockInfo( cartographer.GetMapBlocks()[4] ).name
	if		common.CompareWString( L, common.GetAddonRelatedText( "localization_rus" ) ) == 0 then return "rus"
	elseif	common.CompareWString( L, common.GetAddonRelatedText( "localization_eng" ) ) == 0 then return "eng"
	elseif	common.CompareWString( L, common.GetAddonRelatedText( "localization_ger" ) ) == 0 then return "ger"
	elseif	common.CompareWString( L, common.GetAddonRelatedText( "localization_fra" ) ) == 0 then return "fra"
	end
	return "eng"
end

--------------------------------------------------------------------------------
-- ChatInputTypeLocalisation: types[ChatInputType][Localisation]
--------------------------------------------------------------------------------

Global("loc",nil)
Global("types",{
	 ["say"]		= {["rus"]="say" 		, ["eng"]="say" 		, ["ger"]="say" 		, ["fra"]="say"},
	 ["zone"]		= {["rus"]="zone" 		, ["eng"]="zone" 		, ["ger"]="zone" 		, ["fra"]="zone"},
	 ["tell"]		= {["rus"]="tell" 		, ["eng"]="whisper" 	, ["ger"]="whisper"		, ["fra"]="tell"},
	 ["reset"]		= {["rus"]="reset" 		, ["eng"]="reset" 		, ["ger"]="reset" 		, ["fra"]="reset"},--german: broken (it is "" (empty string)? o.O)
	 ["raidwarning"]= {["rus"]="raidwarning", ["eng"]="raidwarning" , ["ger"]="raidwarning" , ["fra"]="raidwarning"},--is this the 1.1.01+ feature?
	 ["raid"]		= {["rus"]="raid" 		, ["eng"]="raid" 		, ["ger"]="raid" 		, ["fra"]="raid"},
	 ["party"]		= {["rus"]="party"		, ["eng"]="party" 		, ["ger"]="party" 		, ["fra"]="party"},
	 ["guild"]		= {["rus"]="guild" 		, ["eng"]="guild" 		, ["ger"]="guild" 		, ["fra"]="guild"},
	 ["officer"]	= {["rus"]="officer" 	, ["eng"]="officer" 	, ["ger"]="officer" 	, ["fra"]="officer"},
	 ["mystic"]		= {["rus"]="mystic" 	, ["eng"]="telepathy" 	, ["ger"]="telepathy" 	, ["fra"]="mystic"},
	 ["yell"]		= {["rus"]="yell" 		, ["eng"]="shout" 		, ["ger"]="shout" 		, ["fra"]="yell"},
	 ["world"]		= {["rus"]="world" 		, ["eng"]="world" 		, ["ger"]="world" 		, ["fra"]="world"}})

--------------------------------------------------------------------------------
-- REACTION HANDLERS
--------------------------------------------------------------------------------
-- On Left Buttons
function OnWBGeneralReaction(params)
	mission.SetChatInputType(types["say"][loc])
end
function OnWBZoneReaction(params)
	mission.SetChatInputType(types["zone"][loc])
end
function OnWBTellReaction(params)
	SPlayerName = object.GetName(avatar.GetTarget())
	mission.SetChatInputType(types["tell"][loc])--SPlayerName
end
function OnWBReReaction(params)
	--mission.SetChatInputType("tell").cmdArg=SPlayerName; -- Я хз как инпуту сказать что он приват + передать туда 1 аргумент... КАК?
	mission.SetChatInputType(types["reset"][loc]) -- По идее Ответ, но в данный момент Сброс.
	mission.ClearChatInput()
end


-- mystic
-- On Center Buttons
function OnWBRaidWarReaction(params)
	mission.SetChatInputType(types["raidwarning"][loc])
end
function OnWBRaidReaction(params)
	mission.SetChatInputType(types["raid"][loc])
end
function OnWBPartyReaction(params)
	mission.SetChatInputType(types["party"][loc])
end
function OnWBGuildReaction(params)
	mission.SetChatInputType(types["guild"][loc])
	--OpenChatLine()
end
function OnWBOfficerReaction(params)
	mission.SetChatInputType(types["officer"][loc])
end

-- On Right Buttons
function OnWBMystReaction(params)
	mission.SetChatInputType(types["mystic"][loc])
end
function OnWBYellReaction(params)
	mission.SetChatInputType(types["yell"][loc])
end
function OnWBWorldReaction(params)
	mission.SetChatInputType(types["world"][loc])
end

-- SCRIPT_START_CHATTING
--function OnEventChatMsg(params)
--	mission.SetChatInputType("reset")
--end

-- "EVENT_AVATAR_SECONDARY_TARGET_CHANGED" Тут скрываем/отображаем кнопку ЛС
function OnEventTargetChanged( params )
	local targetId = avatar.GetTarget()	
	if targetId == nil then
		WBTellButton:Show(false)
	else
		if unit.IsPlayer(targetId) then
			WBTellButton:Show(true)
		else
			WBTellButton:Show(false)
		end
	end
	--local result = common.IsEmptyWString(SPlayerName)
	--if result then WBReButton:Show(false) else WBReButton:Show(true) end  -- По идее кнопка Ответа ЛС, но пока это сброс, и по этому видим всегда
end

-- EVENT_TEXT_OBJECT_CLICKED
function OnTextObjectClicked(params)
	local text = params.object:GetText()
	if params.object:GetType() == VAL_OBJ_TYPE_PLAYER then
		--mission.SetChatInputType("tell")
		SPlayerName = text
	end
end

-- EVENT_RAID_CHANGED -- EVENT_RAID_LEADER_CHANGED
function OnRaidChanged(params)
	--common.LogInfo(common.GetAddonName(),"GUI - ", "Raid test" )
	if raid.IsExist() then
		WBRaidButton:Show(true)
		if raid.IsLeader() then WBRaidWarButton:Show(true) else WBRaidWarButton:Show(false) end
	else
		WBRaidWarButton:Show(false) 
		WBRaidButton:Show(false)
	end
	--common.LogInfo(common.GetAddonName(),"GUI - ", "Raid test END" )
end

-- EVENT_GROUP_CHANGED
function OnGroupChanged(params)
	--common.LogInfo(common.GetAddonName(),"GUI - ", "Group test" )
	if group.GetMembers()==nil then WBPartyButton:Show(false) else WBPartyButton:Show(true) end
	--common.LogInfo(common.GetAddonName(),"GUI - ", "Group test END" )
end


-- EVENT_GUILD_CHANGED -- EVENT_GUILD_MEMBER_RANK_CHANGED
function OnGuildChanged(params)
	--common.LogInfo(common.GetAddonName(),"GUI - ", "Guild test" )
	local guildChat = false
	local officerChat = false
	if guild.IsExist() then
		local avRights
		if guild.GetMember then -- AO 1.1.03+
			avRights = guild.GetRights(guild.GetMember(object.GetName(avatar.GetId())))
		else
			avRights = guild.GetRights(object.GetName(avatar.GetId()))
		end
		--common.LogInfo(common.GetAddonName(),"GUI - ", "Guild Right get" )
		--common.LogInfo(common.GetAddonName(),"GUI - ", common.FormatInt(GUILD_MEMBER_RIGHT_OFFICER_CHAT,"%d") )
		--common.LogInfo(common.GetAddonName(),"GUI! - ", common.FormatInt( avRights[GUILD_MEMBER_RIGHT_OFFICER_CHAT],"%d") )
		for i = 0, GetTableSize( avRights ) - 1 do
			if avRights[i] == GUILD_MEMBER_RIGHT_CHAT then
				guildChat = true
				--common.LogInfo(common.GetAddonName(),"GUI - ", "Guild Chat" )
			end
			if avRights[i] == GUILD_MEMBER_RIGHT_OFFICER_CHAT then
				officerChat = true
				--common.LogInfo(common.GetAddonName(),"GUI - ", "Guild ChatOff" )
			end
		end
	end
	if guildChat then WBGuildButton:Show(true) else WBGuildButton:Show(false) end
	if officerChat then WBOfficerButton:Show(true) else WBOfficerButton:Show(false) end
	--common.LogInfo(common.GetAddonName(),"GUI - ", "Guild test END" )
end

-- Проверка класса миста
function IsMyst()
	--common.LogInfo(common.GetAddonName(),"TEST")
	local avClass = avatar.GetClass()  --unit.GetClass(avatar.GetId())
	--common.LogInfo(common.GetAddonName(),avClass)
	if avClass=="PSIONIC" then WBMystButton:Show(true) else WBMystButton:Show(false) end
end

-- For ALT+Z (Hidden)
function OnToggleUI( params )
	WXMainPanel:Show( params.visible )
	--if params.visible then
		--mission.DNDRegister( WXMainPanel, GetDNDId( DND_WIDGET_MOVE, 13 ), false )
	--end
end

--[[
function OnStartChat(params)
	isOpenChat=true
	common.LogInfo(common.GetAddonName(),"Start")
end

-- А вот этот эвент, запускает/отправляет чат... NextVersion
function OpenChatLine(params)
	common.SendEvent( "changed_chat", {} ) 
	if isOpenChat then common.LogInfo(common.GetAddonName(),"TRUE") else common.LogInfo(common.GetAddonName(),"FALSE") end
	if not isOpenChat then common.SendEvent( "SCRIPT_START_CHATTING", {} ) end
end
function OnEnterChat(params)
	common.LogInfo(common.GetAddonName(),"Enter")
	isOpenChat=true
end
function OnEscChat(params)
	common.LogInfo(common.GetAddonName(),"Esc")
	isOpenChat=false
end

-- UTILITY: OpenWindow - тут по идее из старого API открытие строчки ввода... не работает =)
--function OpenXWindow()
	--wtEditLine:SetFocus( true )
	--wtEditLine:Show( true )
	--wtXMainPanel:Show( true )
	--NotifyOfAddonToggledState( true )
	--NotifyOfEscapeSequenceAttendeeState( true )
--end
]]--

--------------------------------------------------------------------------------
-- PositionDifferences (if you change the position of your chat-window ingame (updated at every game start)
-- Works only in AO 1.1.00, and will stop working in AO 1.1.01+.
--------------------------------------------------------------------------------
function GetXDifference()
local chatpos = mission.GetAvatarConfigSection("chat")
if chatpos["dnd"] and chatpos["dnd"]["posX"] then
	return math.floor( chatpos["dnd"]["posX"] - 10 )
else return 0 end
end
function GetYDifference()
local chatpos = mission.GetAvatarConfigSection("chat")
if chatpos["dnd"] and chatpos["dnd"]["highPosY"] and chatpos["dnd"]["sizeY"] then
	return math.floor( chatpos["dnd"]["highPosY"] - 140 + chatpos["dnd"]["sizeY"] - 440 )
else return 0 end
end
--------------------------------------------------------------------------------
-- INITIALIZATION
--------------------------------------------------------------------------------
function Init()
	loc=GetGameLocalization()
	-- Присваиваем основной фрейм
	WXMainPanel = mainForm:GetChildChecked( "MainPanel_ChatBarAO", false )
	-- Присваиваем все кнопки 
	WBGeneralButton = WXMainPanel:GetChildChecked("WBGeneralButton", false)
	WBZoneButton = WXMainPanel:GetChildChecked("WBZoneButton", false)
	WBTellButton = WXMainPanel:GetChildChecked("WBTellButton", false)
	WBReButton = WXMainPanel:GetChildChecked("WBReButton", false)
	
	WBRaidWarButton = WXMainPanel:GetChildChecked("WBRaidWarButton", false)
	WBRaidButton = WXMainPanel:GetChildChecked("WBRaidButton", false)
	WBPartyButton = WXMainPanel:GetChildChecked("WBPartyButton", false)
	WBGuildButton = WXMainPanel:GetChildChecked("WBGuildButton", false)
	WBOfficerButton = WXMainPanel:GetChildChecked("WBOfficerButton", false)
	
	WBMystButton = WXMainPanel:GetChildChecked("WBMystButton", false)
	WBYellButton = WXMainPanel:GetChildChecked("WBYellButton", false)
	WBWorldButton = WXMainPanel:GetChildChecked("WBWorldButton", false)
	
	--wtXMainPanel = mainForm:GetChildChecked( "MainPanel", false )    
	--wtXEditLine = wtXMainPanel:GetChildChecked( "ChatEditLine", false )
	
	-- Регистрируем события кнопочные
	common.RegisterReactionHandler(OnWBGeneralReaction, "WBGeneralReaction")
	common.RegisterReactionHandler(OnWBZoneReaction, "WBZoneReaction")
	common.RegisterReactionHandler(OnWBTellReaction, "WBTellReaction")
	common.RegisterReactionHandler(OnWBReReaction, "WBReReaction")
	
	common.RegisterReactionHandler(OnWBRaidWarReaction, "WBRaidWarReaction")
	common.RegisterReactionHandler(OnWBRaidReaction, "WBRaidReaction")
	common.RegisterReactionHandler(OnWBPartyReaction, "WBPartyReaction")
	common.RegisterReactionHandler(OnWBGuildReaction, "WBGuildReaction")
	common.RegisterReactionHandler(OnWBOfficerReaction, "WBOfficerReaction")
	
	common.RegisterReactionHandler(OnWBMystReaction, "WBMystReaction")
	common.RegisterReactionHandler(OnWBYellReaction, "WBYellReaction")
	common.RegisterReactionHandler(OnWBWorldReaction, "WBWorldReaction")
	
	-- Для продолжения инициализации аддона
	common.RegisterEventHandler( PostInit, "EVENT_AVATAR_CREATED" )
	
	-- ALT+Z Hidden
	common.RegisterEventHandler( OnToggleUI, "SCRIPT_TOGGLE_UI")
	
	-- Для определения tell
	common.RegisterEventHandler( OnEventTargetChanged, "EVENT_AVATAR_SECONDARY_TARGET_CHANGED" )
	--common.RegisterEventHandler( OnEventChatMsg, "EVENT_CHAT_MESSAGE" ) -- нужен ли сброс...?
	common.RegisterEventHandler( OnTextObjectClicked, "EVENT_TEXT_OBJECT_CLICKED" )
	
	-- Для определения raid
	common.RegisterEventHandler( OnRaidChanged, "EVENT_RAID_CHANGED" )
	common.RegisterEventHandler( OnRaidChanged, "EVENT_RAID_LEADER_CHANGED" )
	
	-- Для определения group
	common.RegisterEventHandler( OnGroupChanged, "EVENT_GROUP_CHANGED" )
	
	-- Для определения guild
	common.RegisterEventHandler( OnGuildChanged, "EVENT_GUILD_CHANGED" )
	common.RegisterEventHandler( OnGuildChanged, "EVENT_GUILD_MEMBER_RANK_CHANGED" )
	
	-- In nextVersion
	--common.RegisterEventHandler( OnStartChat, "SCRIPT_START_CHATTING" )
	--common.RegisterEventHandler( OnStartChat, "SCRIPT_CHAT_TALK_REPLY" )
	--common.RegisterEventHandler( OnStartChat, "SCRIPT_POPUP_OPEN_CHAT_LINE" )
	--common.RegisterEventHandler( OnStartChat, "EVENT_TEXT_OBJECT_CLICKED" )
	--common.RegisterEventHandler( OnStartChat, "SCRIPT_CHAT_SLASH_COMMAND" )
	--common.RegisterEventHandler( OnStartChat, "SCRIPT_REGISTER_TALK_REPLY" )

	--common.RegisterReactionHandler( OnEscChat, "escape_chat" )
	--common.RegisterReactionHandler( OnEnterChat, "changed_chat" )
	--common.RegisterReactionHandler( OnEnterChat, "enter_chat" )
	--common.RegisterReactionHandler( OnEnterChat, "panel_pressed" )
	
	WBTellButton:Show(false) -- Пока не работает как надо...
	WBReButton:Show(true) -- Будущий ответ, но пока Сброс
	
	-- Корректируем положение панели в предыдущих версиях АО (EU/US):
	-- Correcting main panel position in older AO versions (EU/US):
	if GetGameVersion() < 1104 then
		local p = WXMainPanel:GetPlacementPlain()
		-- Самое главное, до 1.1.04, приоритет главной формы должен быть гораздо ниже.
		-- Most important, before 1.1.04, main frame priority must be much lower.
		if GetGameVersion() < 1104 then mainForm:SetPriority( 950 ) end
		-- В патче 1.1.03, слева 24 пикселя были закрыты чем-то невидимым.
		-- (Возможно, mainForm:SetPriority( 950 ) решает эту проблему, но я не могу это проверить, т.к. у нас уже 1.1.04).
		-- In 1.1.03 patch, first 24 pixels on the left was overlapped with some invisible in-game panel.
		-- (Maybe, mainForm:SetPriority( 950 ) solves the problem, I can't test it anymore, since we got 1.1.04).
		if GetGameVersion() == 1103 then p.posX = 113 end
		-- До патча 1.1.02, слева не было 2 кнопок эмоций.
		-- Prior to 1.1.02, where was no 2 Emotion buttons on the left.
		if GetGameVersion() < 1102 then p.posX = 12 end
		-- И во всех версиях до 1.1.04, чат находился выше на 24 пикселя выше, по умолчанию.
		-- In all versions prior to 1.1.04, chat window was on 24 pixels higher position by default.
		if GetGameVersion() < 1104 then p.highPosY = 348 end
		-- В версии 1.1.00, всё ещё можно получить позицию окна Чата из User.cfg. Спасибо Carnifex за код.
		-- In AO 1.1.00 it is still posstible to get the Chat window position from User.cfg. Thanks to Carnifex for code.
		if GetGameVersion() == 1100 then
			p.posX = p.posX + GetXDifference()
			p.highPosY = p.highPosY + GetYDifference()
		end
		WXMainPanel:SetPlacementPlain( p )
	end
	
	-- На случай перезапуска аддона Менеджером Аддонов (во время игры):
	if avatar.IsExist() then
		PostInit()
	end
end

-- Продолжение инициализации аддона
function PostInit(params)
	OnGroupChanged()
	OnRaidChanged()
	OnGuildChanged()
	IsMyst()
end

--------------------------------------------------------------------------------
Init()
--------------------------------------------------------------------------------